gdata.tlslite.TLSConnection | index /usr/lib/python2.7/dist-packages/gdata/tlslite/TLSConnection.py

`MAIN CLASS FOR TLS LITE (START HERE!).`

Modules

``

array base64 binascii | hmac math md5 | os sha socket | sys traceback

Classes

``

gdata.tlslite.TLSRecordLayer.TLSRecordLayer
  TLSConnection

class TLSConnection(gdata.tlslite.TLSRecordLayer.TLSRecordLayer)

``

`This class wraps a socket and provides TLS handshaking and data
transfer.
To use this class, create a new instance, passing a connected
socket into the constructor. Then call some handshake function.
If the handshake completes without raising an exception, then a TLS
connection has been negotiated. You can transfer data over this
connection as if it were a socket.
This class provides both synchronous and asynchronous versions of
its key functions. The synchronous versions should be used when
writing single-or multi-threaded code using blocking sockets. The
asynchronous versions should be used when performing asynchronous,
event-based I/O with non-blocking sockets.
Asynchronous I/O is a complicated subject; typically, you should
not use the asynchronous functions directly, but should use some
framework like asyncore or Twisted which TLS Lite integrates with
(see
L{tlslite.integration.TLSAsyncDispatcherMixIn.TLSAsyncDispatcherMixIn} or
L{tlslite.integration.TLSTwistedProtocolWrapper.TLSTwistedProtocolWrapper}).
`

Methods defined here:

__init__(self, sock)
  `Create a new TLSConnection instance.
  @param sock: The socket data will be transmitted on. The
  socket should already be connected. It may be in blocking or
  non-blocking mode.
  @type sock: L{socket.socket}`

handshakeClientCert(self, certChain=None, privateKey=None, session=None, settings=None, checker=None, async=False)
  `Perform a certificate-based handshake in the role of client.
  This function performs an SSL or TLS handshake. The server
  will authenticate itself using an X.509 or cryptoID certificate
  chain. If the handshake succeeds, the server's certificate
  chain will be stored in the session's serverCertChain attribute.
  Unless a checker object is passed in, this function does no
  validation or checking of the server's certificate chain.
  If the server requests client authentication, the
  client will send the passed-in certificate chain, and use the
  passed-in private key to authenticate itself. If no
  certificate chain and private key were passed in, the client
  will attempt to proceed without client authentication. The
  server may or may not allow this.
  Like any handshake function, this can be called on a closed
  TLS connection, or on a TLS connection that is already open.
  If called on an open connection it performs a re-handshake.
  If the function completes without raising an exception, the
  TLS connection will be open and available for data transfer.
  If an exception is raised, the connection will have been
  automatically closed (if it was ever open).
  @type certChain: L{tlslite.X509CertChain.X509CertChain} or
  L{cryptoIDlib.CertChain.CertChain}
  @param certChain: The certificate chain to be used if the
  server requests client authentication.
  @type privateKey: L{tlslite.utils.RSAKey.RSAKey}
  @param privateKey: The private key to be used if the server
  requests client authentication.
  @type session: L{tlslite.Session.Session}
  @param session: A TLS session to attempt to resume. If the
  resumption does not succeed, a full handshake will be
  performed.
  @type settings: L{tlslite.HandshakeSettings.HandshakeSettings}
  @param settings: Various settings which can be used to control
  the ciphersuites, certificate types, and SSL/TLS versions
  offered by the client.
  @type checker: L{tlslite.Checker.Checker}
  @param checker: A Checker instance. This instance will be
  invoked to examine the other party's authentication
  credentials, if the handshake completes succesfully.
  @type async: bool
  @param async: If False, this function will block until the
  handshake is completed. If True, this function will return a
  generator. Successive invocations of the generator will
  return 0 if it is waiting to read from the socket, 1 if it is
  waiting to write to the socket, or will raise StopIteration if
  the handshake operation is completed.
  @rtype: None or an iterable
  @return: If 'async' is True, a generator object will be
  returned.
  @raise socket.error: If a socket error occurs.
  @raise tlslite.errors.TLSAbruptCloseError: If the socket is closed
  without a preceding alert.
  @raise tlslite.errors.TLSAlert: If a TLS alert is signalled.
  @raise tlslite.errors.TLSAuthenticationError: If the checker
  doesn't like the other party's authentication credentials.`

handshakeClientSRP(self, username, password, session=None, settings=None, checker=None, async=False)
  `Perform an SRP handshake in the role of client.
  This function performs a TLS/SRP handshake. SRP mutually
  authenticates both parties to each other using only a
  username and password. This function may also perform a
  combined SRP and server-certificate handshake, if the server
  chooses to authenticate itself with a certificate chain in
  addition to doing SRP.
  TLS/SRP is non-standard. Most TLS implementations don't
  support it. See
  U{http://www.ietf.org/html.charters/tls-charter.html} or
  U{http://trevp.net/tlssrp/} for the latest information on
  TLS/SRP.
  Like any handshake function, this can be called on a closed
  TLS connection, or on a TLS connection that is already open.
  If called on an open connection it performs a re-handshake.
  If the function completes without raising an exception, the
  TLS connection will be open and available for data transfer.
  If an exception is raised, the connection will have been
  automatically closed (if it was ever open).
  @type username: str
  @param username: The SRP username.
  @type password: str
  @param password: The SRP password.
  @type session: L{tlslite.Session.Session}
  @param session: A TLS session to attempt to resume. This
  session must be an SRP session performed with the same username
  and password as were passed in. If the resumption does not
  succeed, a full SRP handshake will be performed.
  @type settings: L{tlslite.HandshakeSettings.HandshakeSettings}
  @param settings: Various settings which can be used to control
  the ciphersuites, certificate types, and SSL/TLS versions
  offered by the client.
  @type checker: L{tlslite.Checker.Checker}
  @param checker: A Checker instance. This instance will be
  invoked to examine the other party's authentication
  credentials, if the handshake completes succesfully.
  @type async: bool
  @param async: If False, this function will block until the
  handshake is completed. If True, this function will return a
  generator. Successive invocations of the generator will
  return 0 if it is waiting to read from the socket, 1 if it is
  waiting to write to the socket, or will raise StopIteration if
  the handshake operation is completed.
  @rtype: None or an iterable
  @return: If 'async' is True, a generator object will be
  returned.
  @raise socket.error: If a socket error occurs.
  @raise tlslite.errors.TLSAbruptCloseError: If the socket is closed
  without a preceding alert.
  @raise tlslite.errors.TLSAlert: If a TLS alert is signalled.
  @raise tlslite.errors.TLSAuthenticationError: If the checker
  doesn't like the other party's authentication credentials.`

handshakeClientSharedKey(self, username, sharedKey, settings=None, checker=None, async=False)
  `Perform a shared-key handshake in the role of client.
  This function performs a shared-key handshake. Using shared
  symmetric keys of high entropy (128 bits or greater) mutually
  authenticates both parties to each other.
  TLS with shared-keys is non-standard. Most TLS
  implementations don't support it. See
  U{http://www.ietf.org/html.charters/tls-charter.html} for the
  latest information on TLS with shared-keys. If the shared-keys
  Internet-Draft changes or is superceded, TLS Lite will track
  those changes, so the shared-key support in later versions of
  TLS Lite may become incompatible with this version.
  Like any handshake function, this can be called on a closed
  TLS connection, or on a TLS connection that is already open.
  If called on an open connection it performs a re-handshake.
  If the function completes without raising an exception, the
  TLS connection will be open and available for data transfer.
  If an exception is raised, the connection will have been
  automatically closed (if it was ever open).
  @type username: str
  @param username: The shared-key username.
  @type sharedKey: str
  @param sharedKey: The shared key.
  @type settings: L{tlslite.HandshakeSettings.HandshakeSettings}
  @param settings: Various settings which can be used to control
  the ciphersuites, certificate types, and SSL/TLS versions
  offered by the client.
  @type checker: L{tlslite.Checker.Checker}
  @param checker: A Checker instance. This instance will be
  invoked to examine the other party's authentication
  credentials, if the handshake completes succesfully.
  @type async: bool
  @param async: If False, this function will block until the
  handshake is completed. If True, this function will return a
  generator. Successive invocations of the generator will
  return 0 if it is waiting to read from the socket, 1 if it is
  waiting to write to the socket, or will raise StopIteration if
  the handshake operation is completed.
  @rtype: None or an iterable
  @return: If 'async' is True, a generator object will be
  returned.
  @raise socket.error: If a socket error occurs.
  @raise tlslite.errors.TLSAbruptCloseError: If the socket is closed
  without a preceding alert.
  @raise tlslite.errors.TLSAlert: If a TLS alert is signalled.
  @raise tlslite.errors.TLSAuthenticationError: If the checker
  doesn't like the other party's authentication credentials.`

handshakeClientUnknown(self, srpCallback=None, certCallback=None, session=None, settings=None, checker=None, async=False)
  `Perform a to-be-determined type of handshake in the role of client.
  This function performs an SSL or TLS handshake. If the server
  requests client certificate authentication, the
  certCallback will be invoked and should return a (certChain,
  privateKey) pair. If the callback returns None, the library
  will attempt to proceed without client authentication. The
  server may or may not allow this.
  If the server requests SRP authentication, the srpCallback
  will be invoked and should return a (username, password) pair.
  If the callback returns None, the local implementation will
  signal a user_canceled error alert.
  After the handshake completes, the client can inspect the
  connection's session attribute to determine what type of
  authentication was performed.
  Like any handshake function, this can be called on a closed
  TLS connection, or on a TLS connection that is already open.
  If called on an open connection it performs a re-handshake.
  If the function completes without raising an exception, the
  TLS connection will be open and available for data transfer.
  If an exception is raised, the connection will have been
  automatically closed (if it was ever open).
  @type srpCallback: callable
  @param srpCallback: The callback to be used if the server
  requests SRP authentication. If None, the client will not
  offer support for SRP ciphersuites.
  @type certCallback: callable
  @param certCallback: The callback to be used if the server
  requests client certificate authentication.
  @type session: L{tlslite.Session.Session}
  @param session: A TLS session to attempt to resume. If the
  resumption does not succeed, a full handshake will be
  performed.
  @type settings: L{tlslite.HandshakeSettings.HandshakeSettings}
  @param settings: Various settings which can be used to control
  the ciphersuites, certificate types, and SSL/TLS versions
  offered by the client.
  @type checker: L{tlslite.Checker.Checker}
  @param checker: A Checker instance. This instance will be
  invoked to examine the other party's authentication
  credentials, if the handshake completes succesfully.
  @type async: bool
  @param async: If False, this function will block until the
  handshake is completed. If True, this function will return a
  generator. Successive invocations of the generator will
  return 0 if it is waiting to read from the socket, 1 if it is
  waiting to write to the socket, or will raise StopIteration if
  the handshake operation is completed.
  @rtype: None or an iterable
  @return: If 'async' is True, a generator object will be
  returned.
  @raise socket.error: If a socket error occurs.
  @raise tlslite.errors.TLSAbruptCloseError: If the socket is closed
  without a preceding alert.
  @raise tlslite.errors.TLSAlert: If a TLS alert is signalled.
  @raise tlslite.errors.TLSAuthenticationError: If the checker
  doesn't like the other party's authentication credentials.`

handshakeServer(self, sharedKeyDB=None, verifierDB=None, certChain=None, privateKey=None, reqCert=False, sessionCache=None, settings=None, checker=None)
  `Perform a handshake in the role of server.
  This function performs an SSL or TLS handshake. Depending on
  the arguments and the behavior of the client, this function can
  perform a shared-key, SRP, or certificate-based handshake. It
  can also perform a combined SRP and server-certificate
  handshake.
  Like any handshake function, this can be called on a closed
  TLS connection, or on a TLS connection that is already open.
  If called on an open connection it performs a re-handshake.
  This function does not send a Hello Request message before
  performing the handshake, so if re-handshaking is required,
  the server must signal the client to begin the re-handshake
  through some other means.
  If the function completes without raising an exception, the
  TLS connection will be open and available for data transfer.
  If an exception is raised, the connection will have been
  automatically closed (if it was ever open).
  @type sharedKeyDB: L{tlslite.SharedKeyDB.SharedKeyDB}
  @param sharedKeyDB: A database of shared symmetric keys
  associated with usernames. If the client performs a
  shared-key handshake, the session's sharedKeyUsername
  attribute will be set.
  @type verifierDB: L{tlslite.VerifierDB.VerifierDB}
  @param verifierDB: A database of SRP password verifiers
  associated with usernames. If the client performs an SRP
  handshake, the session's srpUsername attribute will be set.
  @type certChain: L{tlslite.X509CertChain.X509CertChain} or
  L{cryptoIDlib.CertChain.CertChain}
  @param certChain: The certificate chain to be used if the
  client requests server certificate authentication.
  @type privateKey: L{tlslite.utils.RSAKey.RSAKey}
  @param privateKey: The private key to be used if the client
  requests server certificate authentication.
  @type reqCert: bool
  @param reqCert: Whether to request client certificate
  authentication. This only applies if the client chooses server
  certificate authentication; if the client chooses SRP or
  shared-key authentication, this will be ignored. If the client
  performs a client certificate authentication, the sessions's
  clientCertChain attribute will be set.
  @type sessionCache: L{tlslite.SessionCache.SessionCache}
  @param sessionCache: An in-memory cache of resumable sessions.
  The client can resume sessions from this cache. Alternatively,
  if the client performs a full handshake, a new session will be
  added to the cache.
  @type settings: L{tlslite.HandshakeSettings.HandshakeSettings}
  @param settings: Various settings which can be used to control
  the ciphersuites and SSL/TLS version chosen by the server.
  @type checker: L{tlslite.Checker.Checker}
  @param checker: A Checker instance. This instance will be
  invoked to examine the other party's authentication
  credentials, if the handshake completes succesfully.
  @raise socket.error: If a socket error occurs.
  @raise tlslite.errors.TLSAbruptCloseError: If the socket is closed
  without a preceding alert.
  @raise tlslite.errors.TLSAlert: If a TLS alert is signalled.
  @raise tlslite.errors.TLSAuthenticationError: If the checker
  doesn't like the other party's authentication credentials.`

handshakeServerAsync(self, sharedKeyDB=None, verifierDB=None, certChain=None, privateKey=None, reqCert=False, sessionCache=None, settings=None, checker=None)
  `Start a server handshake operation on the TLS connection.
  This function returns a generator which behaves similarly to
  handshakeServer(). Successive invocations of the generator
  will return 0 if it is waiting to read from the socket, 1 if it is
  waiting to write to the socket, or it will raise StopIteration
  if the handshake operation is complete.
  @rtype: iterable
  @return: A generator; see above for details.`

Methods inherited from gdata.tlslite.TLSRecordLayer.TLSRecordLayer:

close(self)
  `Close the TLS connection.
  This function will block until it has exchanged close_notify
  alerts with the other party. After doing so, it will shut down the
  TLS connection. Further attempts to read through this connection
  will return "". Further attempts to write through this connection
  will raise ValueError.
  If makefile() has been called on this connection, the connection
  will be not be closed until the connection object and all file
  objects have been closed.
  Even if an exception is raised, the connection will have been
  closed.
  @raise socket.error: If a socket error occurs.
  @raise tlslite.errors.TLSAbruptCloseError: If the socket is closed
  without a preceding alert.
  @raise tlslite.errors.TLSAlert: If a TLS alert is signalled.`

closeAsync(self)
  `Start a close operation on the TLS connection.
  This function returns a generator which behaves similarly to
  close(). Successive invocations of the generator will return 0
  if it is waiting to read from the socket, 1 if it is waiting
  to write to the socket, or will raise StopIteration if the
  close operation has completed.
  @rtype: iterable
  @return: A generator; see above for details.`

getCipherImplementation(self)
  `Get the name of the cipher implementation used with
  this connection.
  @rtype: str
  @return: The name of the cipher implementation used with
  this connection. Either 'python', 'cryptlib', 'openssl',
  or 'pycrypto'.`

getCipherName(self)
  `Get the name of the cipher used with this connection.
  @rtype: str
  @return: The name of the cipher used with this connection.
  Either 'aes128', 'aes256', 'rc4', or '3des'.`

getpeername(self)
  `Return the remote address to which the socket is connected
  (socket emulation).`

getsockname(self)
  `Return the socket's own address (socket emulation).`

gettimeout(self)
  `Return the timeout associated with socket operations (socket
  emulation).`

makefile(self, mode='r', bufsize=-1)
  `Create a file object for the TLS connection (socket emulation).
  @rtype: L{tlslite.FileObject.FileObject}`

read(self, max=None, min=1)
  `Read some data from the TLS connection.
  This function will block until at least 'min' bytes are
  available (or the connection is closed).
  If an exception is raised, the connection will have been
  automatically closed.
  @type max: int
  @param max: The maximum number of bytes to return.
  @type min: int
  @param min: The minimum number of bytes to return
  @rtype: str
  @return: A string of no more than 'max' bytes, and no fewer
  than 'min' (unless the connection has been closed, in which
  case fewer than 'min' bytes may be returned).
  @raise socket.error: If a socket error occurs.
  @raise tlslite.errors.TLSAbruptCloseError: If the socket is closed
  without a preceding alert.
  @raise tlslite.errors.TLSAlert: If a TLS alert is signalled.`

readAsync(self, max=None, min=1)
  `Start a read operation on the TLS connection.
  This function returns a generator which behaves similarly to
  read(). Successive invocations of the generator will return 0
  if it is waiting to read from the socket, 1 if it is waiting
  to write to the socket, or a string if the read operation has
  completed.
  @rtype: iterable
  @return: A generator; see above for details.`

recv(self, bufsize)
  `Get some data from the TLS connection (socket emulation).
  @raise socket.error: If a socket error occurs.
  @raise tlslite.errors.TLSAbruptCloseError: If the socket is closed
  without a preceding alert.
  @raise tlslite.errors.TLSAlert: If a TLS alert is signalled.`

send(self, s)
  `Send data to the TLS connection (socket emulation).
  @raise socket.error: If a socket error occurs.`

sendall(self, s)
  `Send data to the TLS connection (socket emulation).
  @raise socket.error: If a socket error occurs.`

setsockopt(self, level, optname, value)
  `Set the value of the given socket option (socket emulation).`

settimeout(self, value)
  `Set a timeout on blocking socket operations (socket emulation).`

write(self, s)
  `Write some data to the TLS connection.
  This function will block until all the data has been sent.
  If an exception is raised, the connection will have been
  automatically closed.
  @type s: str
  @param s: The data to transmit to the other party.
  @raise socket.error: If a socket error occurs.`

writeAsync(self, s)
  `Start a write operation on the TLS connection.
  This function returns a generator which behaves similarly to
  write(). Successive invocations of the generator will return
  1 if it is waiting to write to the socket, or will raise
  StopIteration if the write operation has completed.
  @rtype: iterable
  @return: A generator; see above for details.`

Functions

``

sha1 = openssl_sha1(...)
  `Returns a sha1 hash object; optionally initialized with a string`

Data

``

cryptlibpyLoaded = False
generators = _Feature((2, 2, 0, 'alpha', 1), (2, 3, 0, 'final', 0), 0)
gmpyLoaded = False
goodGroupParameters = [(2, 167609434410335061...389658897350067939L), (2, 148699818592312829...022696100064262587L), (2, 217661744586174357...299250924469288819L), (2, 580960599536995806...769998514148343807L), (5, 104438888141315250...045385534758453247L), (5, 337515218214385611...109988915707117567L), (5, 109074813561941592...353154294858383359L)]
m2cryptoLoaded = False
prngName = 'os.urandom'
pycryptoLoaded = False
sieve = [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, ...]